import PropTypes from 'prop-types';
import { createComponent } from 'cf-style-container';

var ModalFooter = createComponent(function (_ref) {
  var theme = _ref.theme,
      _ref$simple = _ref.simple,
      simple = _ref$simple === undefined ? false : _ref$simple;
  return {
    position: 'relative',
    paddingTop: theme.space[3],
    paddingBottom: theme.space[3],
    paddingRight: theme.space[4],
    paddingLeft: theme.space[4],
    background: simple ? 'transparent' : theme.colors.dust,

    '&::after': {
      content: '""',
      display: 'table',
      clear: 'both'
    }
  };
});
ModalFooter.setDisplayName('ModalFooter');

ModalFooter.propTypes = {
  simple: PropTypes.bool,
  children: PropTypes.node
};

ModalFooter.defaultProps = {
  simple: false
};

export default ModalFooter;