'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _cfComponentIcon = require('cf-component-icon');

var _cfStyleContainer = require('cf-style-container');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const ModalCloseWrapper = (0, _cfStyleContainer.createComponent)(({ theme }) => ({
  cursor: 'pointer',
  right: theme.space[3],
  top: theme.space[3],
  position: 'absolute',
  lineHeight: 0.6
}), 'div', ['onClick']);
ModalCloseWrapper.setDisplayName('ModalCloseWrapper');

class ModalClose extends _react2.default.Component {
  render() {
    return _react2.default.createElement(
      ModalCloseWrapper,
      { onClick: this.props.onClick },
      _react2.default.createElement(_cfComponentIcon.Icon, { type: 'remove', label: this.props.label })
    );
  }
}

ModalClose.propTypes = {
  onClick: _propTypes2.default.func.isRequired,
  label: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.bool])
};

ModalClose.defaultProps = {
  label: false
};

exports.default = ModalClose;