'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _cfStyleContainer = require('cf-style-container');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const ModalFooter = (0, _cfStyleContainer.createComponent)(({ theme, simple = false }) => ({
  position: 'relative',
  paddingTop: theme.space[3],
  paddingBottom: theme.space[3],
  paddingRight: theme.space[4],
  paddingLeft: theme.space[4],
  background: simple ? 'transparent' : theme.colors.dust,

  '&::after': {
    content: '""',
    display: 'table',
    clear: 'both'
  }
}));
ModalFooter.setDisplayName('ModalFooter');

ModalFooter.propTypes = {
  simple: _propTypes2.default.bool,
  children: _propTypes2.default.node
};

ModalFooter.defaultProps = {
  simple: false
};

exports.default = ModalFooter;